import request from '@/utils/request';
import type { ApiResult } from '@/api/index';
import type { User } from '@/api/system/user/model';
import type { UpdatePasswordParam } from './model';
import type {CmsWebsite} from "@/api/cms/cmsWebsite/model";
import {SERVER_API_URL} from "@/utils/server";

/**
 * 获取网站信息
 */
export async function getShopInfo() {
  const res = await request.get<ApiResult<CmsWebsite>>(
    '/shop/getShopInfo'
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 获取当前登录的用户信息、菜单、权限、角色
 */
export async function getUserInfo(): Promise<User> {
  const res = await request.get<ApiResult<User>>(SERVER_API_URL + '/auth/user');
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

export async function updateUserInfo(data: User): Promise<User> {
  const res = await request.put<ApiResult<unknown>>(
    SERVER_API_URL + '/auth/user',
    data
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 获取服务器时间(实时)
 * @return
 */
export async function getServerTime() {
  const res = await request.get<ApiResult<any>>(
    '/cms/website/getServerTime'
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 获取未来7天的日期
 * @return
 */
export async function getNext7day() {
  const res = await request.get<ApiResult<any>>(
    '/cms/website/getNext7day'
  );
  console.log('res.data.code: ', res.data.code);
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 向子模块传递token
 * @param url
 */
export async function transferToken(url: string): Promise<string> {
  const res = await request.get<ApiResult<unknown>>(url);
  return Promise.reject(new Error(res.message));
}

/**
 * 修改当前登录的用户密码
 */
export async function updatePassword(
  data: UpdatePasswordParam
): Promise<string> {
  const res = await request.put<ApiResult<unknown>>(
    '/auth/password',
    data
  );
  if (res.code === 0) {
    return res.message ?? '修改成功';
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 获取微信小程序登录凭证
 */

export async function getWxOpenId(data: any) {
  const res = await request.post<ApiResult<any>>(SERVER_API_URL + '/wx-login/getWxOpenId',data);
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}


// 获取微信openId
export async function loginByOpenId(data: any) {
  const res = await request.post<ApiResult<any>>(SERVER_API_URL + '/wx-login/loginByOpenId', data);
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
